// FSHBumpView.cpp : CFSHBumpView NX̓̒`s܂B
//

#include "stdafx.h"
#include "FSHBump.h"

#include "FSHBumpDoc.h"
#include "FSHBumpView.h"

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <GL/gl.h>
#include <GL/glu.h>

#include "toglExtensions.h"
#include "toglimg/toglimg.h"
#include "toglmatrix/toglmatrix.h"

#ifndef M_PI
#	define M_PI	3.14159265358979323846
#endif /* M_PI */

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CString bumpShader = 
"!!ARBfp1.0													\n\
															\n\
OUTPUT	output = result.color;								\n\
# PARAM	amb = program.local[1];								\n\
															\n\
PARAM	zero = { 0.0, 0.0, 0.0, 1.0 };						\n\
PARAM	normal = { 0.0, 0.0, 1.0, 1.0 };					\n\
PARAM	m_one = {-1.0, -1.0, -1.0, -1.0 };					\n\
PARAM	two = { 2.0, 2.0, 2.0, 2.0 };						\n\
															\n\
TEMP	temp, lVect, viewV, halfV, invLen;					\n\
TEMP	light;												\n\
TEMP	color, ambient, diffuse, specular;					\n\
TEMP	image, bump;										\n\
															\n\
TEX		image, fragment.texcoord[0], texture[0], 2D;		\n\
TEX		bump, fragment.texcoord[0], texture[1], 2D;			\n\
MAD		bump, bump, two, m_one;								\n\
DP3		temp, bump, bump;									\n\
RSQ		invLen, temp.x;										\n\
MUL		bump, bump, invLen;									\n\
															\n\
DP3		temp, fragment.texcoord[1], fragment.texcoord[1];	\n\
RSQ		invLen, temp.x;										\n\
MUL		lVect, fragment.texcoord[1], invLen;				\n\
															\n\
DP3		light, lVect, normal;								\n\
SLT		light, zero, light;									\n\
															\n\
DP3		diffuse, lVect, bump;								\n\
MUL		diffuse, diffuse, light;							\n\
MUL		diffuse, diffuse, state.light[0].diffuse;			\n\
MAX		diffuse, diffuse, zero;								\n\
															\n\
DP3		temp, fragment.texcoord[2], fragment.texcoord[2];	\n\
RSQ		invLen, temp.x;										\n\
MUL		viewV, fragment.texcoord[2], invLen;				\n\
															\n\
ADD		halfV, viewV, lVect;								\n\
DP3		temp, halfV, halfV;									\n\
RSQ		invLen, temp.x;										\n\
MUL		halfV, halfV, invLen;								\n\
															\n\
DP3		specular, halfV, bump;								\n\
MUL		specular, specular, light;							\n\
POW		specular, specular.r, state.material.shininess.r;	\n\
MUL		specular, specular, state.light[0].specular;		\n\
MAX		specular, specular, zero;							\n\
															\n\
ADD		color, diffuse, state.lightmodel.scenecolor;		\n\
MUL		color, image, color;								\n\
MAD		color, state.material.specular, specular, color;	\n\
															\n\
ADD		output, state.material.emission, color;				\n\
															\n\
END															\n";

/////////////////////////////////////////////////////////////////////////////
// CFSHBumpView

IMPLEMENT_DYNCREATE(CFSHBumpView, CView)

BEGIN_MESSAGE_MAP(CFSHBumpView, CView)
	//{{AFX_MSG_MAP(CFSHBumpView)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_ERASEBKGND()
	ON_WM_SIZE()
	ON_WM_TIMER()
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFSHBumpView NX̍\z/

CFSHBumpView::CFSHBumpView()
{
	// TODO: ̏ꏊɍ\zp̃R[hǉĂB

	m_hglrc = NULL;
	m_width = 0;
	m_height = 0;
	m_count = 0L;

	m_shaderID = 0;

	m_position[0] = 0.0f;
	m_position[1] = 0.0f;
	m_position[2] = 5.0f;
	m_position[3] = 1.0f;

	m_lightPosition[0] = 5.0f;
	m_lightPosition[1] = 5.0f;
	m_lightPosition[2] = 5.0f;
	m_lightPosition[3] = 1.0f;
}

CFSHBumpView::~CFSHBumpView()
{
}

BOOL CFSHBumpView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CFSHBumpView NX̕`

void CFSHBumpView::OnDraw(CDC* pDC)
{
	CFSHBumpDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: ̏ꏊɃlCeBu f[^p̕`R[hǉ܂B

	float	lightAmbient[] = { 0.0f, 0.0f, 0.0f, 1.0f };
	float	lightDiffuse[] = { 1.0f, 1.0f, 1.0f, 1.0f };
	float	lightSpecular[] = { 1.0f, 1.0f, 1.0f, 1.0f };

	float	materialAmbient[] = { 1.0f, 1.0f, 1.0f, 1.0f };
	float	materialDiffuse[] = { 1.0f, 1.0f, 1.0f, 1.0f };
	float	materialSpecular[] = { 1.0f, 1.0f, 1.0f, 1.0f };
	float	materialShininess = 64.0f;
	float	materialEmission[] = { 0.0f, 0.0f, 0.0f, 1.0f };


	::wglMakeCurrent(pDC->m_hDC, m_hglrc);

	::glEnable(GL_CULL_FACE);
	::glEnable(GL_DEPTH_TEST);

	::glClearColor(0.68f, 0.68f, 0.68f, 1.0f);
	::glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	::glLoadIdentity();
	::gluLookAt(m_position[0], m_position[1], m_position[2], 0.0f, 0.0f, 0.0f, 0.0f, 1.0f, 0.0f);

	::glGetFloatv(GL_MODELVIEW_MATRIX, m_viewMatrix);

	m_lightPosition[0] = 8.0f * cos(((m_count + 180) % 360) * M_PI / 180.0);
	m_lightPosition[1] = 
		5.0f * cos((int((m_count + 180) * 3.3333) % 360) * M_PI / 180.0) +
		-3.0f * sin((int((m_count + 180) * 7.1) % 360) * M_PI / 180.0);
	m_lightPosition[2] = - 8.0f * sin(((m_count + 180) % 360) * M_PI / 180.0);

	::glLightfv(GL_LIGHT0, GL_POSITION, m_lightPosition);
	::glLightfv(GL_LIGHT0, GL_AMBIENT, lightAmbient);
	::glLightfv(GL_LIGHT0, GL_DIFFUSE, lightDiffuse);
	::glLightfv(GL_LIGHT0, GL_SPECULAR, lightSpecular);

	::glPushAttrib(GL_ALL_ATTRIB_BITS);

//	::glEnable(GL_TEXTURE_2D);

	::glEnable(GL_FRAGMENT_PROGRAM_ARB);

	::glBindTexture(GL_TEXTURE_2D, m_texID[0]);

	::glPushMatrix();
		::glTranslatef(-1.0f, 0.0f, 0.0f);
		::glRotatef((m_count / 3) % 360, -1.0f, 1.0f, 0.0f);

		::glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT,  materialAmbient);
		::glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE,  materialDiffuse);
		::glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR,  materialSpecular);
		::glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS,  materialShininess);
		::glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION,  materialEmission);

		DrawSphere(2.0);
	::glPopMatrix();

	/***********************************************************************/

	::glBindTexture(GL_TEXTURE_2D, m_texID[1]);

	::glPushMatrix();
		::glTranslatef(2.0f, 0.0f, -1.0f);
		::glRotatef(30.0f, 1.0f, 1.0f, 0.0f);
		::glRotatef((m_count / 4) % 360, 0.0f, 1.0f, 0.0f);

		::glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT,  materialAmbient);
		::glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE,  materialDiffuse);
		::glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR,  materialSpecular);
		::glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS,  materialShininess);
		::glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION,  materialEmission);

		DrawSphere(1.0);
	::glPopMatrix();	

	::glPopAttrib();

	::glFlush();
	::SwapBuffers(pDC->m_hDC);

	::wglMakeCurrent(NULL, NULL);
}

/////////////////////////////////////////////////////////////////////////////
// CFSHBumpView NX̐ff

#ifdef _DEBUG
void CFSHBumpView::AssertValid() const
{
	CView::AssertValid();
}

void CFSHBumpView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CFSHBumpDoc* CFSHBumpView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CFSHBumpDoc)));
	return (CFSHBumpDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CFSHBumpView NX̃bZ[W nh

int CFSHBumpView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: ̈ʒuɌŗL̍쐬pR[hǉĂ
	
	TOGLimage	img[2], bump;

	::toglInitImage(&img[0]);
	if (!::toglReadImageJPEG("image1.jpg", &img[0])) {
		AfxMessageBox("Err");
	}

	::toglInitImage(&img[1]);
	if (!::toglReadImageJPEG("image2.jpg", &img[1])) {
		AfxMessageBox("Err");
	}

	::toglInitImage(&bump);
	if (!::toglReadImageJPEG("bump.jpg", &bump)) {
		AfxMessageBox("Err");
	}

	::toglImageBumpmapToNormalmap(&bump, 5.0f);


	CClientDC dc(this);

	PIXELFORMATDESCRIPTOR pfd = { 
		sizeof(PIXELFORMATDESCRIPTOR),   // size of this pfd 
		1,                     // version number 
		PFD_DRAW_TO_WINDOW |   // support window 
		PFD_SUPPORT_OPENGL |   // support OpenGL 
		PFD_DOUBLEBUFFER,      // double buffered 
		PFD_TYPE_RGBA,         // RGBA type 
		24,                    // 24-bit color depth 
		0, 0, 0, 0, 0, 0,      // color bits ignored 
		0,                     // no alpha buffer 
		0,                     // shift bit ignored 
		0,                     // no accumulation buffer 
		0, 0, 0, 0,            // accum bits ignored 
		32,                    // 32-bit z-buffer 
		0,                     // no stencil buffer 
		0,                     // no auxiliary buffer 
		PFD_MAIN_PLANE,        // main layer 
		0,                     // reserved 
		0, 0, 0                // layer masks ignored 
	}; 
	int  iPixelFormat; 
 
	// get the best available match of pixel format for the device context  
	iPixelFormat = ::ChoosePixelFormat(dc.m_hDC, &pfd); 
 
	// make that the pixel format of the device context 
	::SetPixelFormat(dc.m_hDC, iPixelFormat, &pfd); 

	// create a rendering context 
	m_hglrc = ::wglCreateContext (dc.m_hDC);	

	::wglMakeCurrent(dc.m_hDC, m_hglrc);

	m_flag_ARB_multitexture = ::SetupExtension("GL_ARB_multitexture");
	m_flag_ARB_fragment_program = ::SetupExtension("GL_ARB_fragment_program");

	if (!m_flag_ARB_multitexture) {
		::AfxMessageBox(_T("Error: Not Support GL_ARB_multitexture"));
		return -1;
	}
	if (!m_flag_ARB_fragment_program) {
		::AfxMessageBox(_T("Error: Not Support GL_ARB_fragment_program"));
		return -1;
	}


	float lightModelAmbient[] = { 0.2f, 0.2f, 0.2f, 1.0f };

	::glLightModelfv(GL_LIGHT_MODEL_AMBIENT, lightModelAmbient);

	::glGenProgramsARB(1, &m_shaderID);
	::glBindProgramARB(GL_FRAGMENT_PROGRAM_ARB, m_shaderID);

	::glProgramStringARB(GL_FRAGMENT_PROGRAM_ARB, GL_PROGRAM_FORMAT_ASCII_ARB, bumpShader.GetLength(), bumpShader); 

	int err_line;
	::glGetIntegerv(GL_PROGRAM_ERROR_POSITION_ARB, &err_line);

	if (err_line != -1) {
		CString msg;
		msg.Format("Error : line=%d\r\n", err_line);
		MessageBox(msg + bumpShader.Mid(err_line));
	}

	::glGenTextures(3, m_texID);

	/* eNX` */
	::glActiveTextureARB(GL_TEXTURE0_ARB);
	::glBindTexture(GL_TEXTURE_2D, m_texID[0]);
	::glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, img[0].m_width, img[0].m_height, 0, GL_RGBA, GL_UNSIGNED_BYTE, img[0].m_buffer);

	::glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	::glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	::glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	::glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);

	::glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);

	/* eNX` */
	::glBindTexture(GL_TEXTURE_2D, m_texID[1]);
	::glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, img[1].m_width, img[1].m_height, 0, GL_RGBA, GL_UNSIGNED_BYTE, img[1].m_buffer);

	::glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	::glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	::glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	::glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);

	::glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);

	/* ov}bsO */
	::glActiveTextureARB(GL_TEXTURE1_ARB);
	::glBindTexture(GL_TEXTURE_2D, m_texID[2]);
	::glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, bump.m_width, bump.m_height, 0, GL_RGBA, GL_UNSIGNED_BYTE, bump.m_buffer);

	::glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	::glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	::glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	::glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);

	::glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);

	::glActiveTextureARB(GL_TEXTURE0_ARB);

	::wglMakeCurrent(NULL, NULL);

	::toglDeleteImage(&img[0]);
	::toglDeleteImage(&img[1]);
	::toglDeleteImage(&bump);

	SetTimer(1, 1, NULL);

	return 0;
}

void CFSHBumpView::OnDestroy() 
{
	CView::OnDestroy();
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ

	CClientDC dc(this);
	::wglMakeCurrent(dc.m_hDC, m_hglrc);

	if (m_shaderID) {
		::glDeleteProgramsARB(1, &m_shaderID);
		m_shaderID = 0;
	}

	::glDeleteTextures(3, m_texID);

	::glFlush();
	::wglMakeCurrent(NULL, NULL);

	::wglDeleteContext(m_hglrc);
	m_hglrc = NULL;	
}

void CFSHBumpView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ

	if (cx == 0 || cy == 0) {
		return;
	}
	
	m_width = cx;
	m_height = cy;

	if (!m_hglrc) {
		return;
	}

	CClientDC dc(this);
	::wglMakeCurrent(dc.m_hDC, m_hglrc);

	::glViewport(0, 0, m_width, m_height);

	::glMatrixMode(GL_PROJECTION);
	::glLoadIdentity();
	::gluPerspective(60.0f, (float)m_width / (float)m_height, 1.0f, 1000.0f);
	::glMatrixMode(GL_MODELVIEW);

	::glFlush();
	::wglMakeCurrent(NULL, NULL);	
}

BOOL CFSHBumpView::OnEraseBkgnd(CDC* pDC) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	
//	return CView::OnEraseBkgnd(pDC);

	return TRUE;
}

void CFSHBumpView::DrawSphere(double radius)
{
	double	theta, pai;
	double	co, si;
	double	co2, si2;
	double	r1, r2;
	double	h1, h2;
	float	v[4][3];
	float	s[3], t[3], n[3];
	float	vv[3];
	float	texcoord[4][2];
	float	modelView[16], invModelView[16], invModel[16];
	float	localView[4], localLight[4];


//	::glProgramLocalParameter4fARB(GL_FRAGMENT_PROGRAM_ARB, 1, 1.0f, 0.6f, 0.6f, 1.0f);

	::glPushMatrix();
	::glScaled(radius, radius, radius);

	::glGetFloatv(GL_MODELVIEW_MATRIX, modelView);

	/* _ACg̈ʒu[JWɕϊ */
	::toglMatrixInversefv(invModelView, modelView);
	::toglMatrixMultMMfv(invModel, invModelView, m_viewMatrix);
	::toglMatrixMultMV4fv(localLight, invModel, m_lightPosition);
	::toglMatrixMultMV4fv(localView, invModel, m_position);

	for (pai = -90.0; pai < 90.0; pai += 10.0) {
		r1 = cos(pai * M_PI / 180.0);
		r2 = cos((pai + 10.0) * M_PI / 180.0);
		h1 = sin(pai * M_PI / 180.0);
		h2 = sin((pai + 10.0) * M_PI / 180.0);

		for (theta = 0.0; theta < 360.0; theta += 10.0) {
			co = cos(theta * M_PI / 180.0);
			si = sin(theta * M_PI / 180.0);
			co2 = cos((theta + 10.0) * M_PI / 180.0);
			si2 = sin((theta + 10.0) * M_PI / 180.0);

			v[0][0] = float(r1 * co2);
			v[0][1] = float(h1);
			v[0][2] = float(r1 * si2);
			v[1][0] = float(r1 * co);
			v[1][1] = float(h1);
			v[1][2] = float(r1 * si);
			v[2][0] = float(r2 * co);
			v[2][1] = float(h2);
			v[2][2] = float(r2 * si);
			v[3][0] = float(r2 * co2);
			v[3][1] = float(h2);
			v[3][2] = float(r2 * si2);

			texcoord[0][0] = 1.0f - (theta + 10.0) / 360.0f;
			texcoord[0][1] = (pai + 90.0) / 180.0f;
			texcoord[1][0] = 1.0f - theta / 360.0f;
			texcoord[1][1] = (pai + 90.0) / 180.0f;
			texcoord[2][0] = 1.0f - theta / 360.0f;
			texcoord[2][1] = (pai + 10.0 + 90.0) / 180.0f;
			texcoord[3][0] = 1.0f - (theta + 10.0) / 360.0f;
			texcoord[3][1] = (pai + 10.0 + 90.0) / 180.0f;


			::glBegin(GL_QUADS);

			int i;
			for (i = 0; i < 4; i++) {

				/***********/

				s[0] = v[i][2];
				s[1] = 0.0f;
				s[2] = - v[i][0];
				::toglVertexNormalize3fv(s, s);

				/***********/

				::toglVertexNormalize3fv(vv, v[i]);

				t[0] = vv[1] * s[2] - s[1] * vv[2];
				t[1] = vv[2] * s[0] - vv[0] * s[2];
				t[2] = vv[0] * s[1] - vv[1] * s[0];
				::toglVertexNormalize3fv(t, t);

				/***********/

				n[0] = s[1] * t[2] - t[1] * s[2];
				n[1] = s[2] * t[0] - s[0] * t[2];
				n[2] = s[0] * t[1] - s[1] * t[0];
				::toglVertexNormalize3fv(n, n);

				/***********/

				::glMultiTexCoord2fARB(GL_TEXTURE0_ARB, texcoord[i][0] * 2, texcoord[i][1] * 2);
				::glMultiTexCoord3fARB(GL_TEXTURE1_ARB, 
					localLight[0] * s[0] + localLight[1] * s[1] + localLight[2] * s[2],
					localLight[0] * t[0] + localLight[1] * t[1] + localLight[2] * t[2],
					localLight[0] * n[0] + localLight[1] * n[1] + localLight[2] * n[2]
				);
				::glMultiTexCoord3fARB(GL_TEXTURE2_ARB, 
					localView[0] * s[0] + localView[1] * s[1] + localView[2] * s[2],
					localView[0] * t[0] + localView[1] * t[1] + localView[2] * t[2],
					localView[0] * n[0] + localView[1] * n[1] + localView[2] * n[2]
				);
				::glNormal3fv(v[i]);
				::glVertex3fv(v[i]);
			}

			::glEnd();
		}
		::glFlush();
	}

	::glPopMatrix();
}

void CFSHBumpView::OnTimer(UINT nIDEvent) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	
	KillTimer(1);

	/////////////////
	MSG	msg;
	while (::PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE)) {
		if (!::AfxGetApp()->PumpMessage()) {
			::PostQuitMessage(0);
			return;
		}
	}

	LONG lIdle = 0;
	while (::AfxGetApp()->OnIdle(lIdle++)){
		;
	}
	/////////////////

	m_count++;

	Invalidate(FALSE);	

	SetTimer(1, 1, NULL);

	CView::OnTimer(nIDEvent);
}

void CFSHBumpView::OnAppAbout() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	
	KillTimer(1);

	/////////////////
	MSG	msg;
	while (::PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE)) {
		if (!::AfxGetApp()->PumpMessage()) {
			::PostQuitMessage(0);
			return;
		}
	}

	LONG lIdle = 0;
	while (::AfxGetApp()->OnIdle(lIdle++)){
		;
	}
	/////////////////

	((CFSHBumpApp *)::AfxGetApp())->OnAppAbout();

	SetTimer(1, 1, NULL);
}
