/*
 * toglmatrix.h
 *
 * Copyright (C) 2002,2003 Tadamasa Teranishi
 */

#ifndef TOGL_MATRIX_HEADER
#define	TOGL_MATRIX_HEADER

#ifdef	WIN32
#include <windows.h>

#pragma warning(disable : 4244)     // MIPS
#pragma warning(disable : 4136)     // X86
#pragma warning(disable : 4051)     // ALPHA
#endif	/* WIN32 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <GL/gl.h>
#include <GL/glu.h>

#undef DLL

#ifdef WIN32
#	ifdef TOGLMATRIX_EXPORTS
#		define	DLL   __declspec( dllexport )
#	else
#		define	DLL   __declspec( dllimport )
#	endif
#endif	/* WIN32 */

#ifndef DLL
#	define DLL
#endif

#ifndef	GLvoid
#	define GLvoid	void
#endif	/* GLvoid */

#ifdef __cplusplus	/*	defined __cplusplus	*/
extern "C" {
#endif

/* 1.0 */
DLL GLvoid toglVertexCopy3fv(float output[3], float vector[3]);
DLL GLvoid toglVertexCopy4fv(float output[4], float vector[4]);
DLL GLvoid toglVertexCopy3dv(double output[3], double vector[3]);
DLL GLvoid toglVertexCopy4dv(double output[4], double vector[4]);
DLL GLboolean toglVertexNormalize3fv(float output[3], float vector[3]);
DLL GLboolean toglVertexNormalize4fv(float output[4], float vector[4]);
DLL GLboolean toglVertexNormalize3dv(double output[3], double vector[3]);
DLL GLboolean toglVertexNormalize4dv(double output[4], double vector[4]);
DLL GLboolean toglMatrixInversefv(float output[16], float matrix[16]);
DLL GLvoid toglMatrixMultMV3fv(float output[3], float matrix[16], float vector[3]);
DLL GLvoid toglMatrixMultMV4fv(float output[4], float matrix[16], float vector[4]);
DLL GLvoid toglMatrixMultMMfv(float output[16], float mat1[16], float mat2[16]);

#define toglMatrixLocalToWorld3fv(output, matrix, vector)	toglMatrixMultMV3fv(output, matrix, vector)
#define toglMatrixLocalToWorld4fv(output, matrix, vector)	toglMatrixMultMV4fv(output, matrix, vector)

#ifdef __cplusplus	/*	defined __cplusplus	*/
}
#endif

#endif /* TOGL_MATRIX_HEADER */
